                                                     (* 29.3.1997  *)
{
 Lemniskate als Einhuellende von Kreisen die auf einer Hyperbel liegen,
 und deren Radius jeweils der Abstand vom aktuellen Hyperbelpunkt zum
 Mittelpunkt der Hyperbel darstellt.
 }   
PROGRAM Lemni2;
USES CRT,GRAPH,UNIGRA12;

CONST
Eps = 1.0E-12;

TYPE
Line2D = RECORD                                                     
             O: Pt2D;
             U: Vt2D;
           END;

Circle = RECORD                                                      
             M: Pt2D;
             R: EXTENDED;
           END;

VAR
  Tangente : Line2D;
 
{ ------------------------- Unterprogramme ------------------------------ }
PROCEDURE NormLinie;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'WU0');
               WRITE(AUX,'UL');              (* 6.:                        *)
               WRITE(AUX,'PW0.15');          (* 0.15 mm                    *)
               WRITE(AUX,'LT');              (* solid                      *)
    END;
    SetLineStyle(0,0,1);
  END;

PROCEDURE Hilfslinie0;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'UL8,1,9,1,9,1,9');  (* 1.:                       *)
               WRITE(AUX,'PW0');              (* ganz schwache Hilfslinie: *)
               WRITE(AUX,'LT8,4.0,1');       
    END;
    SetLineStyle(4,$8080,1);
  END;

PROCEDURE Hilfslinie1;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'UL8,1,9,1,9,1,9');  (* 1.:                       *)
               WRITE(AUX,'PW0');              (* ganz schwache Hilfslinie: *)
               WRITE(AUX,'LT8,4.0,1');       
    END;
    SetLineStyle(4,$8080,1);
  END;

PROCEDURE HilfsLinie2;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'UL8,2,7,2,7,2,7');  (* 2.:                       *)
               WRITE(AUX,'PW0');              (* staerkere Hilfslinie      *)
               WRITE(AUX,'LT8,2.0,1');      
    END;
    SetLineStyle(1,0,1);
  END;

PROCEDURE DuenneLinie;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'UL');              
               WRITE(AUX,'PW0');           (*  *)
               WRITE(AUX,'LT');
    END;
    SetLineStyle(0,0,1);
  END;

PROCEDURE StrichPunktiert;                   (* als Symmetrieachse         *)
  BEGIN
    IF PLOT THEN BEGIN WRITE(AUX,'UL8,8,2,2,2,8,2,2,2,8,2,2,2'); 
               WRITE(AUX,'PW0');             (* duennste Linie             *)
               WRITE(AUX,'LT8,15.0,1');      (* strichpunktiert mit klein. *)
    END;                                     (* Strich als Punkt           *)
    SetLineStyle(4,$F18F,1);                  
  END;                                           
   
Procedure Ausgangszustand_definieren;
   BEGIN                                     (* FALSE = EGAVGA.BGI        *) 
   IF PLOT THEN Plotter_einschalten;
   WinitGraph(0,3,'');
   Weltgrenzen_festlegen(einh);
   Viewport_festlegen;

   IF PLOT THEN GeraetefensterPlotter_festlegen;
   Parameter2D;
   IF PLOT THEN Portrait  := FALSE;        (* Querformat Bild liegend      *)
   IF PLOT THEN WRITE(AUX,'WU0');          (* width unit absolut in mm     *)
   Plast.X := WI2D[1].X;                 (* letzter Punkt initialisieren   *)
   Plast.Y := WI2D[1].Y;
   Portrait  := FALSE;                   (* Querformat Bild liegend        *)
   Viewport_zeichnen;
   Hilfslinie0; 
   Koordinatenachsen_zeichnen;
   Normlinie;
  { Gitter(0.3,2.0,10.0);}(* Strich,              klE,             grE     *)
                       (* grosse Strichlaenge,kleine Einheit, grosse Einh *)
   Col := 15;
  END;

Procedure Beschriftung(M: Pt2D; A,B : EXTENDED);
  VAR
  T: Ttyp;
  XUntergr,XObergr,YUntergr,YObergr,einhS: STRING[Bz1];
  MXS,MYS,AS,BS : STRING[Bz1];
  Ttemp1,Ttemp2: STRING[Bz2];
  BEGIN
  STR(WI2D[1].X:5:1,XUntergr); STR(WI2D[1].Y:5:1,YUntergr);
  STR(WI2D[2].X:5:1,XObergr);  STR(WI2D[2].Y:5:1,YObergr);
  STR(einh:5:2,einhS);
  STR(M.X:5:2,MXS); STR(M.Y:5:2,MYS);
  STR(A:5:2,AS);    STR(B:5:2,BS);

(* ----------------------------- TEXTE --------------------------------- *)
  T[1] := ' Lemniskate als Einhuellende:';
  Ttemp1 := 'durch Kreise auf der Hyperbel: M('+MXS+'/'+MYS+')   A: ';
  Ttemp2 := AS+' B: '+BS;
  T[2] := Ttemp1 + Ttemp2;
        Ttemp1 := 'Weltgrenzen: X von '+XUntergr+' bis '+XObergr;
        Ttemp2 := '   Y von '+YUntergr+' bis '+YObergr;
  T[3] := Ttemp1 + Ttemp2;
  T[4] := '1 Einheit entspricht '+einhS+'  cm';
  IF Plot THEN WRITE(AUX,'SP1');                (* sonst kein Ausdruck !! *)
  Text_ausgeben(T,3);                                 (* 2 Texte ausgeben *)
  END;

PROCEDURE MakeVt2D(P1,P2: Pt2D; VAR V: Vt2D);
  BEGIN
   V.X := P2.X - P1.X;
   V.Y := P2.Y - P1.Y;
  END;

PROCEDURE SumVt2D(V1,V2:Vt2D; VAR V: Vt2D);
  BEGIN
   V.X := V1.X + V2.X;
   V.Y := V1.Y + V2.Y;
  END;

PROCEDURE LengthVt2D(V: Vt2D; VAR L: EXTENDED);
BEGIN
  L := SQRT(SQR(V.X)+SQR(V.Y)+Eps);
END;

PROCEDURE LinearCombinationVt2D(S1,S2: EXTENDED; V1,V2: Vt2D; VAR LC: Vt2D);
BEGIN
  LC.X:=S1*V1.X+S2*V2.X;
  LC.Y:=S1*V1.Y+S2*V2.Y;
END;

PROCEDURE ScaleVt2D(V: Vt2D; LG: EXTENDED; VAR ScalV: Vt2D);
VAR L: EXTENDED;
BEGIN
  ScalV:=V;
  LengthVt2D(V, L);
  IF NOT Null(L,Eps) THEN BEGIN
    ScalV.X:=V.X/L*LG;
    ScalV.Y:=V.Y/L*LG;
  END;
END;

PROCEDURE TToLine2D(Ln2D: Line2D; T: EXTENDED; VAR P: Pt2D);
BEGIN
  LinearCombinationVt2D(1,T,Ln2D.O,Ln2D.U, P);
END;

PROCEDURE MakeLine2D(P1,P2: Pt2D; VAR Line: Line2D);
  VAR
  hv : Vt2D;
  BEGIN
    MakeVt2D(P1,P2,hv);
    ScaleVt2D(hv,1.0,hv);
    Line.O := P1;
    Line.U := hv;
  END;

PROCEDURE Wsymm(V1,V2: Vt2d; P: Pt2D; VAR Wsym: Line2D);
VAR
V,V0: Vt2d;
  BEGIN
    SumVt2d(V1,V2,V);
    ScaleVt2D(V,1.0,V0);
    Wsym.U := V0;
    Wsym.O :=  P;
  END;

PROCEDURE KreisTtoP(Kreis: Circle; T: EXTENDED; VAR P: Pt2D);
  BEGIN
    P.X := Kreis.M.X+Kreis.R*COS(T);
    P.Y := Kreis.M.Y+Kreis.R*SIN(T);
  END;

PROCEDURE NormDistance(Line: Line2D; P: Pt2D; VAR Dist : EXTENDED);
  VAR
  H,N0 : Vt2D;
  D : EXTENDED;
  BEGIN
    H.X := -Line.U.Y; H.Y := Line.U.X;        (* vorlaeufiger Normalvektor *)
    IF(Line.O.X*H.X + Line.O.Y*H.Y) < 0.0 THEN BEGIN
      H.X := -H.X;                            (* Orientierung aendern, so  *)
      H.Y := -H.Y;                            (* dass Konst immer positiv  *)
      END;
    ScaleVt2D(H,1.0,N0);                        (*  sollte schon 1 sein !! *)
    D := N0.X*Line.O.X + N0.Y*Line.O.Y;
    Dist := N0.X*P.X + N0.Y*P.Y-D;
  END;

PROCEDURE Zeichne_Kreis(Kreis: Circle; TMin,TMax: EXTENDED; TSteps : INTEGER;
                        Col: INTEGER);
   VAR
     I: INTEGER;
     T,DeltaT: EXTENDED;
     P: Pt2D;
     QS,QE : BOOLEAN;
     ZeichenI:Interval2D;
   BEGIN
     ZeichenI := WI2D;
     DuenneLinie;
     DeltaT := (TMax-TMin)/TSteps;
     T := TMin;                                         
     KreisTtoP(Kreis,T,P);
     MoveToPt2D(P);
     FOR I := 0 TO TSteps DO
       BEGIN
         T := TMin + I*DeltaT;
         KreisTtoP(Kreis,T,P);
 
 IF((P.Y<ZeichenI[1].Y) OR (P.Y>ZeichenI[2].Y) OR (P.X<ZeichenI[1].X)
           OR (P.X>ZeichenI[2].X)) THEN
           BEGIN
             QE := FALSE
           END ELSE BEGIN
             QE := TRUE;
           END;
   IF(QS AND QE) THEN
     BEGIN                             (* Wenn Start und Endpunkt TRUE,    *)
     DrawLine2D(PLast,P,Col);            (* dann ziehe Linie               *)
     END ELSE BEGIN
       MovetoPt2D(P);                       (* sonst unsichtbar ziehen     *)
   END;
   QS := QE;                           (* neuer Startpunkt ist alter Endp. *)
       END;
     Normlinie;
    END;


    
PROCEDURE HyperbelTtoP(MP : Pt2D; A,B,T: EXTENDED;
                       VAR P : Pt2D);
 CONST
 Eps = 1.0E-8;
  BEGIN
    IF NOT Null(COS(T),Eps)THEN BEGIN
      P.X := MP.X + A/COS(T);
      P.Y := MP.Y + B*(SIN(T)/COS(T));
    END;
  END;

PROCEDURE Hyperbel;
  VAR
  Phi,DPhi : EXTENDED;                        (* Phi = Parameter f. Kreis  *)
  
  P    : Pt2D;                                      (* laufender Hyp.Punkt *)
                     (*    nE    : EXTENDED; numerische Exzentrizitae      *)
                     (* = Verhaeltnis von Hyp.Punkt-BrennPunkt zu          *)
                     (*                   Hyp.Punkt-Leitlinie              *)
                     (* nE = lineare Exzentrizitaet/A                      *)
                     (* lin Exz. = SQRT(a^2 + B^2)                         *)
                     (* 2p = 2B^2/A            Parameter                   *)
  MP: Pt2D;
  A,B : EXTENDED;
  QS,QE : BOOLEAN;
  ZeichenI:Interval2D;
  Huellkreis : Circle;
  H : Vt2D;
  PH : Pt2D;
  BEGIN
    QS := TRUE;
    ZeichenI[1].X := -30.0;   ZeichenI[1].Y := -30.0;
    ZeichenI[2].X :=  30.0;   ZeichenI[2].Y :=  30.0;
    MP.X := 0.0; MP.Y := 0.0; A := 4.0; B := 3.0;              (* Hyperbel *)
    DuenneLinie;
    Col := 15;
    DPhi := 0.0;                    (* Anfangswert oder Phasenverschiebung *)
    Phi := 0.0;
    HyperbelTtoP(MP,A,B,Phi,P);
    MovetoPt2D(P);
    WHILE Phi <= 2.0*PI+0.3 DO BEGIN
          
      HyperbelTtoP(MP,A,B,Phi,P);
      HuellKreis.M := P;
      MakeVt2d(P,MP,H);
      LengthVt2D(H,HuellKreis.R);

      IF((P.Y<ZeichenI[1].Y) OR (P.Y>ZeichenI[2].Y) OR (P.X<ZeichenI[1].X)
           OR (P.X>ZeichenI[2].X)) THEN
           BEGIN
             QE := FALSE
           END ELSE BEGIN
             QE := TRUE;
           END;
   IF(QS AND QE) THEN
     BEGIN                             (* Wenn Start und Endpunkt TRUE,    *)
     {PutPt2D(P,14);}
     PH := P;
     StrichPunktiert;
     DrawtoPt2D(P,14);
     NormLinie;
   Zeichne_Kreis(HuellKreis,0.0,2.0*Pi,90,15);
     MovetoPt2D(P);
     END ELSE BEGIN
       MovetoPt2D(P);                       (* sonst unsichtbar ziehen     *)
   END;
   QS := QE;                           (* neuer Startpunkt ist alter Endp. *)
      Phi := Phi + 2.0*Pi/60.0;
    END;
    NormLinie;
    Beschriftung(MP,A,B);
  END;

{ -------------------------- main program -------------------------------- }
BEGIN
 Schnittstelle_waehlen(1);                 (* 2 bedeutet auf Datei plotten *)
  Plot := FALSE;                           (* 1 ist parallele Schnittst    *)
  einh := 0.5;   (* 1 Einheit auf der X-Achse und Y-Achse entspricht .. cm *)
  WI2D[1].X := -26.7;  WI2D[1].Y := -20.0;     (* linker unterer Punkt     *)
                                               (* des Weltfensters         *)
  Ausgangszustand_definieren;                 (* Graphikgrundeinstellung   *)
  Hyperbel;
  WClosegraph;
END.